#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

void rijeci() {
    FILE* f_ptr = fopen("ulaz.txt", "r");

    if (f_ptr == NULL) {
        printf("Neuspjesno otvaranje fajla\n");
    }
    else {
        char rijec[100];
        fscanf(f_ptr, "%s", rijec);
        while (!feof(f_ptr)) {
            printf("%s\n", rijec);
            fscanf(f_ptr, "%s", rijec);
        }
        fclose(f_ptr);
    }
}

// za vjezbu - sta ako imamo znake interpunkcije

void brojevi() {
    FILE* f_ptr = fopen("ulaz2.txt", "r");
    FILE* izlaz = fopen("izlaz2.txt", "w");

    if (f_ptr == NULL || izlaz == NULL) {
        printf("Neuspjesno otvaranje fajla\n");
    }
    else {
        char line[100];
        fgets(line, 100, f_ptr);
        //fscanf(f_ptr, "%s", line);

        while (!feof(f_ptr)) {

            char* tok = strtok(line, ", ");
            while (tok != NULL) {
                //int x = atoi(tok);
                int x;
                sscanf(tok, "%d", &x);
                printf("%d\n", x);

                if (x % 3 == 0) {
                    fprintf(izlaz, "%d ", x);
                }

                tok = strtok(NULL, ", ");
            }
            fprintf(izlaz, "\n");

            fgets(line, 100, f_ptr);
            //fscanf(f_ptr, "%s", line);
        }

        fclose(f_ptr);
        fclose(izlaz);
    }
}

void brojanje_slova() {
    FILE* f_ptr = fopen("ulaz.txt", "r");
    FILE* izlaz = fopen("izlaz.txt", "w");

    if (f_ptr == NULL || izlaz == NULL) {
        printf("Neuspjesno otvaranje fajla\n");
    }
    else {
        char line[100];
        fgets(line, 100, f_ptr);
        int cnt[26] = {0};
        int i;

        while (!feof(f_ptr)) {

            i = 0;
            while (line[i] != '\0') {
                if (islower(line[i])) {
                    cnt[line[i] - 'a']++;
                }
                i++;
            }

            fgets(line, 100, f_ptr);
        }

        for (i = 0; i < 26; i++) {
            if (cnt[i] > 0)
                fprintf(izlaz, "%c %d\n", i + 'a', cnt[i]);
        }

        fclose(f_ptr);
        fclose(izlaz);
    }
}

// konverziju iz snake_case u camelCase
// binarni_nizovi -> binarniNizovi

void snakecase2camelcase() {
    FILE* ulaz = fopen("program.c", "r");
    FILE* izlaz = fopen("program_camelcase.c", "w");

    if (ulaz == NULL || izlaz == NULL) {
        printf("Neuspjesno otvaranje fajla\n");
    }
    else {
        char line[1000];
        fgets(line, 1000, ulaz);
        char tmp[1000];

        while (!feof(ulaz)) {
            if (line[0] == '\n') {
                fprintf(izlaz, "\n");
                fgets(line, 1000, ulaz);
                continue;
            }

            int i = 0, j = 0;
            while (i < strlen(line) - 2) {
                if (islower(line[i]) && line[i+1] == '_' && islower(line[i+2])) {
                    tmp[j] = line[i];
                    tmp[j+1] = toupper(line[i+2]); // line[i+2] - 'a' + 'A';
                    i += 3;
                    j += 2;
                }
                else {
                    tmp[j] = line[i];
                    i++;
                    j++;
                }
            }
            while (line[i] != '\0') {
                tmp[j] = line[i];
                i++;
                j++;
            }
            tmp[j] = '\0';

            fprintf(izlaz, tmp);

            fgets(line, 1000, ulaz);
        }

        fclose(ulaz);
        fclose(izlaz);
    }
}

int main()
{
    //rijeci();
    //brojevi();
    //brojanje_slova();
    snakecase2camelcase();

    return 0;
}
